//
//  BaseAppDelegate.m
//  Base
//
//  Created by NYU SCPS on 4/16/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "BaseAppDelegate.h"

@implementation BaseAppDelegate


@synthesize window=_window;

//This function is called for each record found in the table.
//It cannot be a method.
//The first argument is the html property of the application delegate.

static int foundRecord(void *p, int argc, char **argv, char **colName) {
	NSMutableArray *records = p;
	
    NSMutableString *s = [[NSMutableString alloc] init];
	for (int i = 0; i < argc; ++i) {
		[s appendFormat: @"%s%s", argv[i], i < argc - 1 ? ", " : ""];	//%s for pointer to char
	}
	
	[records addObject: s];
	return SQLITE_OK;
}

- (BOOL)application:(UIApplication *)application didFinishLaunchingWithOptions:(NSDictionary *)launchOptions
{
    /*
    // Override point for customization after application launch.
    html = [[NSMutableString alloc] initWithString:	
            @"<HTML>\n"
            "<HEAD>\n"
            "<META NAME = \"viewport\" CONTENT = \"width = device-width;\">\n"
            "</HEAD\n\n"
			
            "<BODY>\n"
            "<TABLE BORDER ALIGN = \"CENTER\">\n"
            "<TR>\n"
            "<TH>Last</TH>\n"
            "<TH>First</TH>\n"
            "<TH>SS</TH>\n"
            "</TR>\n"
            ];
     */
    records = [[NSMutableArray alloc] init];
    
	base = NULL;
	
    
	// Override point for customization after application launch.
	NSString *fileName =
    [NSHomeDirectory() stringByAppendingPathComponent: @"Documents/base.db"];
	
	if (sqlite3_open([fileName UTF8String], &base) != SQLITE_OK) {
		NSLog(@"sqlite3_open: %s", sqlite3_errmsg(base));
	}
	
	else {
		char *error;
		if (sqlite3_exec(base, "drop table if exists people;", NULL, NULL, &error) != SQLITE_OK) {
			NSLog(@"sqlite3_exec: %s", error);
			sqlite3_free(error);
		}
        
		else {
            NSLog(@"about to create");
			const char *const create =
            "create table people (\n"
            "	lastname text,\n"
            "	firstname text,\n"
            "	ss integer\n"
            ");";
			
			if (sqlite3_exec(base, create, NULL, NULL, &error) != SQLITE_OK) {
				NSLog(@"sqlite3_exec: %s", error);
				sqlite3_free(error);
			}
            
			else {
                    NSLog(@"about to insert");
				typedef struct {
					char *lastname;
					char *firstname;
					int ss;
				} person_t;
                
				static const person_t a[] = {
					{"Balacek",     "Carol",         1},
					{"Becker",      "Samuel",        2},
					{"Bourne",      "Geoffrey",      3},
					{"Capursi",     "Sergio",        4},
					{"Cattafesta",  "Richard",       5},
					{"Dabas",       "Munish",        6},
					{"Disla",       "Ivan",			 7},
					{"Fallon",      "Brian",         8},
					{"Gaudry",      "Peter",         9},
					{"Gibbons",     "Christopher",  10},
					{"Halderman",   "John",			11},
					{"Harvey",      "James",        12},
					{"Johnson",     "Kevin",        13},
					{"Johnston",    "Douglas",      14},
					{"Jones",       "Scott",        15},
					{"Juro",        "Todd",			16},
					{"Kiser",       "Spencer",      17},
					{"Liao",        "Mark",			18},
					{"Meretzky",    "Mark",			19},
					{"Noreen",      "Sajida",       20},
					{"Park",        "Sohyun",       21},
					{"Parris",      "Jamar",        22},
					{"Pujols",      "Harry",        23},
					{"Ramirez",     "Christian",    24},
					{"Troise",      "Chris",        25},
					{"Williams",    "David",        26},
					{"Wong",        "Yung",			27},
					{"Wu",			"Clement",      28},
					{"Yuen",        "Sammy",        29}
				};
				static const size_t n = sizeof a / sizeof a[0];
                
				for (size_t i = 0; i < n; ++i) {
					char *const insert = sqlite3_mprintf(
                                                         "insert into people (lastname, firstname, ss) values ('%q', '%q', %d);",
                                                         a[i].lastname, a[i].firstname, a[i].ss
                                                         );
                    
					if (insert == NULL) {
						NSLog(@"sqlite3_mprintf failed.");
					}
                    
					char *error;
					if (sqlite3_exec(base, insert, NULL, NULL, &error) != SQLITE_OK) {
						NSLog(@"%s", error);
						sqlite3_free(error);
					}
                    
					sqlite3_free(insert);
                      NSLog(@"inserted");
				}
                
                
				/*
                 The following sqlite3_exec will call foundRecord over and over again, once for
                 each record that it finds.  The first argument that sqlite3_exec passes to
                 foundRecord will be the html string.
                 */
                 NSLog(@"before");
				if (sqlite3_exec(base, "select * from people;", foundRecord, records, &error) != SQLITE_OK) {
					NSLog(@"%@", error);
					sqlite3_free(error);
				}
                 NSLog(@"after");
				
			}
		}
	}
	
    NSLog(@"created");
	UIScreen *screen = [UIScreen mainScreen];
	tableView = [[UITableView alloc]
     initWithFrame: screen.applicationFrame
     style: UITableViewStylePlain
     ];
    tableView.indicatorStyle = UIScrollViewIndicatorStyleDefault; //scroll bar
	tableView.showsVerticalScrollIndicator = YES;   //fade out when stopped
	tableView.scrollsToTop = YES;                   //click on status bar
	tableView.bounces = YES; 
    tableView.dataSource = self;
	
	_window = [[UIWindow alloc] initWithFrame: screen.bounds];
	[self.window addSubview: tableView];
	[self.window makeKeyAndVisible];
	return YES;
}

#pragma mark -
#pragma mark methods of protocol UITableViewDataSource

- (NSInteger) numberOfSectionsInTableView: (UITableView *) v {
    NSLog(@"number");
	return 1;
}

- (NSInteger) tableView: (UITableView *) v
  numberOfRowsInSection: (NSInteger) section {
	
	return records.count;
}

- (UITableViewCell *) tableView: (UITableView *) v
          cellForRowAtIndexPath: (NSIndexPath *) indexPath {
    
    NSLog(@"number");
	static NSString *identifier = @"records";
	UITableViewCell *cell =
    [tableView dequeueReusableCellWithIdentifier: identifier];
	
	if (cell == nil) {
		cell = [[UITableViewCell alloc]
                initWithStyle: UITableViewCellStyleDefault
                reuseIdentifier: identifier
                ];
		[cell autorelease];
	}
	
	cell.textLabel.text = [records objectAtIndex: indexPath.row];
	return cell;
}

- (void)applicationWillResignActive:(UIApplication *)application
{
    /*
     Sent when the application is about to move from active to inactive state. This can occur for certain types of temporary interruptions (such as an incoming phone call or SMS message) or when the user quits the application and it begins the transition to the background state.
     Use this method to pause ongoing tasks, disable timers, and throttle down OpenGL ES frame rates. Games should use this method to pause the game.
     */
}

- (void)applicationDidEnterBackground:(UIApplication *)application
{
    /*
     Use this method to release shared resources, save user data, invalidate timers, and store enough application state information to restore your application to its current state in case it is terminated later. 
     If your application supports background execution, this method is called instead of applicationWillTerminate: when the user quits.
     */
}

- (void)applicationWillEnterForeground:(UIApplication *)application
{
    /*
     Called as part of the transition from the background to the inactive state; here you can undo many of the changes made on entering the background.
     */
}

- (void)applicationDidBecomeActive:(UIApplication *)application
{
    /*
     Restart any tasks that were paused (or not yet started) while the application was inactive. If the application was previously in the background, optionally refresh the user interface.
     */
}

- (void)applicationWillTerminate:(UIApplication *)application
{
    /*
     Called when the application is about to terminate.
     Save data if appropriate.
     See also applicationDidEnterBackground:.
     */
}

- (void)dealloc
{
    [_window release];
    [super dealloc];
}

@end
